#!/usr/bin/env python
# -*- coding: utf-8 -*-
# 
# Copyright 2015 <+YOU OR YOUR COMPANY+>.
# 
# This is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3, or (at your option)
# any later version.
# 
# This software is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this software; see the file COPYING.  If not, write to
# the Free Software Foundation, Inc., 51 Franklin Street,
# Boston, MA 02110-1301, USA.
# 

from gnuradio import gr, gr_unittest
from gnuradio import blocks
from gnuradio import fec
import ngham_swig as ngham

class qa_ngham_encode (gr_unittest.TestCase):

    def setUp (self):
        self.tb = gr.top_block ()

    def tearDown (self):
        self.tb = None

    def test_001_t (self):
        # set up fg
        preamble = (0xAA,)*4    #preamble+
        syncword= (0x5D, 0xE6, 0x2A, 0x7E)
        sizetag = (0x3B,0x49,0xCD)
        header = (0x00,)
        payload = (255,)*28
        crc = (0x24, 0xD2)
        dummy = (0xAA,0xAA)*8
        #expected_data = preamble + syncword  + sizetag + header + payload + crc + dummy
        expected_data = (170, 170, 170, 170, 93, 230, 42, 126, 59, 73, 205, 255, 183, 241, 63, 101, 242, 143, 67, 113, 211, 108, 82, 88, 72, 185, 49, 165, 104, 130, 51, 205, 93, 64, 193, 245, 239, 14, 119, 107, 233, 56, 27, 84, 58, 183, 43, 158, 176, 75, 211, 182, 243, 141, 241, 229, 196, 39)
        src = blocks.vector_source_b(payload)
        ncode = ngham.ngham_encode()
        sink = blocks.vector_sink_b()
        
        #Make connections
        self.tb.connect(src,ncode,sink)
        #self.tb.connect(src,sink)
        
        self.tb.run ()
        # check data
        result = sink.data()

        print("\n\n"+str(result))
        print(len(result))
        print("\n\n"+str(expected_data))
        print(len(expected_data))
        
        #print("\n\n"+str(result[63:]))
        #print("\n\n"+str(expected_data[63:]))
        self.assertEqual(expected_data, result)

      

if __name__ == '__main__':
    gr_unittest.run(qa_ngham_encode, "qa_ngham_encode.xml")
